#include <Eigen/Dense>
#include <iostream>
using namespace std;

int main() {
  int n;
  cout << "n="; cin >> n;
  using MT=Eigen::MatrixX<double>;
  using VT=Eigen::VectorX<double>;
  MT A=MT::Random(n,n); // (invertible) system matrix 
  VT b=VT::Random(n); // right-hand side
  VT x=A.lu().solve(b); // direct solution by LU factorization
  cout << x.transpose() << endl << endl;
  MT X=A.lu().solve(MT::Identity(n,n)); // inversion
  cout << X << endl << "=" << endl << A.inverse() << endl;
  return 0;
}
